<id>
Choose Position on Registration (CPR) YaBB2
</id>

<version>
beta 1.3
</version>

<mod info>
Allows registrants to choose their position from a list of post-independent membergroups.  Admins can also select a registrant's position if they register them in the admin center. Admins have the opiton of allowing a post-independent membergroup to be selectable or not in the membergroup options. 

Installation 
--------------------
1.  Unistall previous version.
2.  Mod the files.
3.  Upload in ASCII Admin.pl, MemberGroups.pl, and ModList.pl to the Admin folder, Register.pl in the Sources folder, cpr.txt to the Variables folder, and cpr.lng to the english language folder.

Version History
---------------
v1.0 - Original release
v1.1 - Removed two lines of code so that the membergroups can be shown.
v1.1a - Updated for Y2 Final Release
v1.2 - Added support for admins to select which membergroup can be selected by user at registration. Fixed several known issues, including one that made the mode not function.  Also fixed an issue if a membergroup is deleted.
v1.3 - Fixed an error that would not allow a user selection of a membergroup be applied to their profile.


Comments
----------------
- If you do not upload the cpr.txt file, you will get errors at both registration screens and membergroups options edit.
</mod info>

<author>
astro-pilot
</author>

<homepage>

</homepage>

<edit file>
Admin/Admin.pl
</edit file>

<search for>
	<tr>
		<td width="30%" class="windowbg"><b>$register_txt{'81'}:</b></td>
		<td width="70%" class="windowbg"><input type="password" maxlength="30" name="passwrd1" size="30" /></td>
	</tr><tr>
		<td width="30%" class="windowbg"><b>$register_txt{'82'}:</b></td>
		<td width="70%" class="windowbg"><input type="password" maxlength="30" name="passwrd2" size="30" /></td>
	</tr>
~;
	}
</search for>

<add after>
### Choose Position on Registration mod ###
LoadLanguage("cpr");
require "$vardir/cpr.txt";
$yymain .= qq~
  <tr class="windowbg">
	<td><b>$cpr_txt{'4'}:</b></td>
 	<td><select name="position"><option></option>~;
while(($key, $value) = each(%NoPost)) {
	($title, $stars, $starpic, $color) = split(/\|/, $value);
	if ($CPR{$title}) {$yymain .= qq~<option value="$key">$title</option>~;}}
### Choose Position on Registration mod end ###
</add after>

<search for>
	$member{'username'} =~ s/\s/_/g;

</search for>

<add after>
	### Choose Position on Registration mod ###
	LoadLanguage("cpr");
	&admin_fatal_error("$cpr_txt{'5'}") if($member{'position'} eq "");
	### Choose Position on Registration mod end ###
</add after>

<search for>
	$reguser      = $member{'username'};
</search for>

<add after>
	$regposition  = $member{'position'}; ### Choose Position on Registration mod ###
</add after>

<search for>
	${$uid.$reguser}{'email'}         = lc($member{'email'});
</search for>

<add after>
	${$uid.$reguser}{'position'} 	  = $regposition; ### Choose Position on Registration mod ###
</add after>

<edit file>
Admin/MemberGroups.pl
</edit file>

<search for>
	<tr>
	  <td class="windowbg"><b>$amgtxt{'42'}</b> <b><a class="link" style='cursor: help;' title="$amgtxt{'43'}">(?)</a></b></td>
	  <td class="windowbg2">
		<input type="checkbox" name="viewpublic" id="viewpublic" value="1"$pc$pd style="vertical-align: middle;" />
	  </td>
	</tr>
~;
	}
</search for>

<add after>
	### Choose Position on Registration mod ###
	LoadLanguage("cpr");
	if ($title) {
		require "$vardir/cpr.txt";
		if ($CPR{$title}) {$cpr = "checked";}	
	}
	$yymain .= qq~
	<tr>
	  <td class="windowbg">$cpr_txt{'6'}</td>
	  <td class="windowbg2">
		<input type="checkbox" name="cprgroup" id="cprgroup" $cpr style="vertical-align: middle;" /><input type="hidden" name="cprgroup1" id="cprgroup1" value="$cpr" /><input type="hidden" name="cprtitle" id="cprtitle" value="$title" />
	  </td>
	</tr>~;
	### Choose Position on Registration mod end ###
</add after>

<search for>
function depend(value)
{
	if (value == "Yes") {
		document.getElementById('posts').disabled = false;
		document.getElementById('viewpublic').checked = true;
		document.getElementById('viewpublic').disabled = true;
	}
	else{
		document.getElementById('posts').disabled = true;
		document.getElementById('viewpublic').disabled = false;
	}
}
</search for>

<replace>
function depend(value)
{
	if (value == "Yes") {
		document.getElementById('posts').disabled = false;
		document.getElementById('viewpublic').checked = true;
		document.getElementById('viewpublic').disabled = true;
		document.getElementById('cprgroup').disabled = true; <!-- ### Choose Position on Registration mod ### // -->
	}
	else{
		document.getElementById('posts').disabled = true;
		document.getElementById('viewpublic').disabled = false;
		document.getElementById('cprgroup').disabled = false; <!-- ### Choose Position on Registration mod ### // -->
	}
}
</replace>

<search for>
			# no post group
			$NoPost{$noposts} = "$name|$FORM{'numstars'}|$star|$color|$viewpublic|$view|$topics|$reply|$polls|$attach";
		}
	}

</search for>

<add after>
	### Choose Position on Registration mod ###
	$cprtitle = $FORM{'cprtitle'};
	if ($cprtitle ne $name) {$cprnamechange = 1;}
	if (($FORM{'cprgroup'} eq 'on' && !$FORM{'cprgroup1'}) || (!$FORM{'cprgroup'} && $FORM{'cprgroup1'} eq "checked") || $cprnamechange) {
		require "$vardir/cpr.txt";
		# Add Group Name from CPR hash
		if ($FORM{'cprgroup'}){ $CPR{$name} = 1;}
		# Remove Group Name from CPR hash
		if (!$FORM{'cprgroup'} || $cprnamechange){
			$cprname99 = $cprnamechange ? $cprtitle : $name;
			delete $CPR{$cprname99};
		}
		#Print CPR hash to file
		fopen (FILE, ">$vardir/cpr.txt");
		foreach my $key (keys %CPR) {
			my $value = $CPR{$key};
			print FILE qq~\$CPR{'$key'} = '$value';\n~;
		}		
		print FILE qq~\n1;~;
		fclose (FILE);	
	}
	### Choose Position on Registration mod end ###

</add after>

<search for>
				delete $NoPost{$element};
				&KillModeratorGroup($element);
</search for>

<add before>
				($title) = split(/\|/, $NoPost{$element}); ### Choose Position on Registration mod ###
</add before>

<search for>
	} else {
		&admin_fatal_error("");
	}

</search for>

<add after>
	### Choose Position on Registration mod ###
	if ($type eq "NP"){	
		require "$vardir/cpr.txt";
		delete $CPR{$title};
		fopen (FILE, ">$vardir/cpr.txt");
		foreach my $key (keys %CPR) {
			my $value = $CPR{$key};
			print FILE qq~\$CPR{'$key'} = '$value';\n~;
		}		
		print FILE qq~\n1;~;
		fclose (FILE);
	}
	### Choose Position on Registration mod end ###

</add after>

<edit file>
Admin/ModList.pl
</edit file>

<search for>
### END BOARDMOD ANCHOR ###
</search for>

<add before>
	$cpr_mod = "CPR 1.3 YaBB2|astro-pilot|Allows registrants to choose their position from a list of post-independent member groups.  Admins can also select a registrant's position if they register them in the admin center.|1.2|12/20/05";
	push (@installed_mods, "$cpr_mod");

</add before>

<edit file>
Sources/Register.pl
</edit file>

<search for>
  </tr><tr class="windowbg">
    <td>* <b>$register_txt{'82'}:</b></td>
    <td><input type="password" maxlength="30" name="passwrd2" value="$tmpregpasswrd2" size="30" /></td>
  </tr>
~;
	}
</search for>

<add after>
### Choose Position on Registration mod ###
LoadLanguage("cpr");
require "$vardir/cpr.txt";
$yymain .= qq~
  <tr class="windowbg">
	<td>* <b>$cpr_txt{'1'}:</b>
	<br><span class="small">$cpr_txt{'2'}</span></td>
 	<td><select name="position"><option></option>~;
while(($key, $value) = each(%NoPost)) {
	($title, $stars, $starpic, $color) = split(/\|/, $value);
	if ($CPR{$title}) {$yymain .= qq~<option value="$key">$title</option>~;}}
$yymain .= qq~    
 </td></tr>~;
### Choose Position on Registration mod end ###
</add after>

<search for>
	$member{'username'} =~ s/\s/_/g;
</search for>

<add after>
	### Choose Position on Registration mod ###
	LoadLanguage("cpr");
	&fatal_error("$cpr_txt{'3'}") if($member{'position'} eq "");
	### Choose Position on Registration mod end ###
</add after>

<search for>
	$reguser      = $member{'username'};
</search for>

<add after>
	$regposition  = $member{'position'}; ### Choose Position on Registration mod ###
</add after>

<search for>
	${$uid.$reguser}{'email'}         = lc($member{'email'});
</search for>

<add after>
	${$uid.$reguser}{'position'} 	  = $regposition; ### Choose Position on Registration mod ###
</add after>